Package org.gridforum.jgss

# Interface ExtendedGSSCredential

All Superinterfaces:
  `Cloneable`, `GSSCredential`

All Known Implementing Classes:
  `GlobusGSSCredentialImpl`

public interface ExtendedGSSCredential extends GSSCredential
Defines Java API for credential export extension as defined in the GSS-API Extensions document. Some of the functions might not specify all the parameters as in the document.
Notes:

- Protection key is currently not supported.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`IMPEXP_MECH_SPECIFIC`
`static final int`
`IMPEXP_OPAQUE`

### Fields inherited from interface org.ietf.jgss.GSSCredential

`ACCEPT_ONLY, DEFAULT_LIFETIME, INDEFINITE_LIFETIME, INITIATE_AND_ACCEPT, INITIATE_ONLY`

## Method Summary

Modifier and Type
Method
Description
`byte[]`
`export(int option)`
Exports this credential so that another process might import it.
`byte[]`
`export(int option, Oid mech)`
Exports this credential so that another process might import it.
`Object`
`inquireByOid(Oid oid)`
Retrieves arbitrary data about this credential.

### Methods inherited from interface org.ietf.jgss.GSSCredential

`add, dispose, equals, getMechs, getName, getName, getRemainingAcceptLifetime, getRemainingInitLifetime, getRemainingLifetime, getUsage, getUsage, hashCode`

## Field Details

### IMPEXP_OPAQUE

static final int IMPEXP_OPAQUE

See Also:
  - Constant Field Values

### IMPEXP_MECH_SPECIFIC

static final int IMPEXP_MECH_SPECIFIC

See Also:
  - Constant Field Values

## Method Details

### export

byte[] export(int option) throws GSSException
Exports this credential so that another process might import it. The exported credential might be imported again using the `ExtendedGSSManager.createCredential` method.

Parameters:
  `option` - The export type. If set to `ExtendedGSSCredential.IMPEXP_OPAQUE` exported buffer is an opaque buffer suitable for storage in memory or on disk or passing to another process. If set to `ExtendedGSSCredential.IMPEXP_MECH_SPECIFIC` exported buffer is a buffer filled with mechanism-specific information that the calling application can use to pass the credential to another process that is not written to the GSS-API.
Returns:
  The buffer containing the credential
Throws:
  `GSSException` - containing the following major error codes: `GSSException.CREDENTIAL_EXPIRED, GSSException.UNAVAILABLE, GSSException.FAILURE`

### export

byte[] export(int option, Oid mech) throws GSSException
Exports this credential so that another process might import it. The exported credential might be imported again using the `ExtendedGSSManager.createCredential` method.

Parameters:
  `option` - The export type. If set to `ExtendedGSSCredential.IMPEXP_OPAQUE` exported buffer is an opaque buffer suitable for storage in memory or on disk or passing to another process. If set to `ExtendedGSSCredential.IMPEXP_MECH_SPECIFIC` exported buffer is a buffer filled with mechanism-specific information that the calling application can use to pass the credential to another process that is not written to the GSS-API.
  `mech` - Desired mechanism for exported credential, may be null to indicate system default.
Returns:
  The buffer containing the credential
Throws:
  `GSSException` - containing the following major error codes: `GSSException.CREDENTIAL_EXPIRED, GSSException.UNAVAILABLE, GSSException.BAD_MECH, GSSException.FAILURE`

### inquireByOid

Object inquireByOid(Oid oid) throws GSSException
Retrieves arbitrary data about this credential.

Parameters:
  `oid` - the oid of the information desired.
Returns:
  the information desired. Might be null.
Throws:
  `GSSException` - containing the following major error codes: `GSSException.FAILURE`